/*
 * FILENAME
 *   dsp.c
 *
 *
 * REMARK
 *  Coeffs for QMF and IQMF FIR filters have to be
 *  scaled by Q15 (32768). 
 *
 *
 *   Rev 1.0  Oct. 30, 2001    M.Rauter <rowdy@sbox.tugraz.at>
 *   Rev 1.1  Nov. 29, 2001    C.Feldbauer
 */

#include "blocks.h"
#include "qmf_short.h"
#include "iqmf_short.h"


#define NUMOFCOEFFS 19  /* modify number if necessary! */


/* global variables */

short qmf_coeffs[NUMOFCOEFFS] = { 43,
0,
-300,
0,
992,
0,
-2697,
0,
10150,
16391,
10150,
0,
-2697,
0,
992,
0,
-300,
0,
43};  /* Paste coefficients here! Don't forget to scale! */




  /* structure for filter object */
struct_qmf_short qmf_data;


  /* additional signal buffers */
short channel_high[BLKSZ];
short channel_low[BLKSZ];



/* Initialize filters here */
void init(void)
{
  qmf_short_init( &qmf_data, qmf_coeffs, NUMOFCOEFFS, BLKSZ);
}



/* Call the necessary functions here */
void processing (void * ptr)
{
  short *sigbuf = ptr;
  
  //qmf_short( &qmf_data, channel_high, channel_low, sigbuf);
  qmf_short( &qmf_data, channel_high, sigbuf, sigbuf);
}
