/**********************************************************************
* FILENAME
*   iqmf_short.c
*
* DESCRIPTION
*   Iqmf filter with high- and lowpass input output
*
* Rev 1.0  Oct 30th 2001 		M. Rauter <rowdy@sbox.tugraz.at>
* Rev 1.1  Oct 30th 2001 		C. Feldbauer
**********************************************************************/

#include"iqmf_short.h"

void iqmf_short_init( struct_iqmf_short *data, short* coeffs, short num_coeff, unsigned blksz)
{
  	data->coeffs = coeffs; // load iqmf coefficients
  	data->blksz = blksz;   // set input blocksize
  	data->states = (int *)malloc( (num_coeff + 1) * sizeof(int)); // memory for waitstates
  	memset( data->states, 0, (num_coeff +1)* sizeof(int)); // for first block -> state(i) =0
  	data->num_coeff=num_coeff; // set # of qmf coefficients
    
}

void iqmf_short( struct_iqmf_short *data, short *sigbuf, short *highin, short *lowin)
{
  int i, j, even, odd;

  for( i=0; i<(data->blksz); i++)
  {
    even=(int)lowin[i]+(int)highin[i];  
    odd =(int)lowin[i]-(int)highin[i];  // define inputs for odd and even coefficients

    for( j=0; j<data->num_coeff; j++)  
    {
      if( j&1) 	// even or odd state?
        data->states[j] = (int)(data->coeffs[j])*odd  + data->states[j+1]; // multiply with odd factor and add preceeding state
      else
        data->states[j] = (int)(data->coeffs[j])*even + data->states[j+1]; // multiply with even factor and add preceeding state
    }
    sigbuf[i] = (short)(data->states[0] >> 15); // write output
  }
	
}
