/**********************************************************************
* FILENAME
*   qmf_short.h
*
* DESCRIPTION
*   Definition of QMF structure and prototypes
*
* Rev 1.0  Oct 29th 2001 		M. Rauter <rowdy@sbox.tugraz.at>
* Rev 1.1  Nov 29th 2001 		C. Feldbauer
**********************************************************************/
#ifndef __QMF_SHORT__
#define __QMF_SHORT__


typedef struct
{
  unsigned blksz;	    // incoming/outgoing signal blocksize
  short num_coeff;    // number of coefficients
  short *coeffs;      // coefficients in Q15
  short *states;      // buffer for delay states  
  int write_index;    // index for cirular buffer
} struct_qmf_short;

/* use the function qmf_short_init() to define the necessary contents of the structure */


/* note: the coefficients have to be in Q15 format */
void qmf_short_init( struct_qmf_short *data, short *coeffs, short num_coeff, unsigned blksz);
void qmf_short( struct_qmf_short *data, short *out_h, short *out_l, short *sigbuf); 

#endif
