/**********************************************************************
* FILENAME
*   iqmf_short.h
*
* DESCRIPTION
*   Definition of IQMF structure and prototypes
*
* Rev 1.0  Oct 29th 2001 		M. Rauter <rowdy@sbox.tugraz.at>
* Rev 1.1  Oct 29th 2001 		C. Feldbauer
**********************************************************************/
#ifndef __IQMF_SHORT__
#define __IQMF_SHORT__


typedef struct
{
  unsigned blksz;	    // incoming/outgoing signal blocksize
  short num_coeff;    // number of coefficients
  short *coeffs;      // pointer of coefficients array
  int *states;        // delay states
} struct_iqmf_short;

/* use the function qmf_short_init() to define the necessary contents of the structure */


/* note: the coefficients have to be in Q15 format */
void iqmf_short_init( struct_iqmf_short *data, short *coeffs, short num_coeff, unsigned blksz);
void iqmf_short( struct_iqmf_short *data, short *outbuf, short *highbuf, short *lowbuf);

#endif
